require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_PARAM_H)) {
    eval 'sub _SYS_PARAM_H () {1;}' unless defined(&_SYS_PARAM_H);
    unless(defined(&ARG_MAX)) {
	eval 'sub __undef_ARG_MAX () {1;}' unless defined(&__undef_ARG_MAX);
    }
    require 'limits.ph';
    require 'linux/limits.ph';
    require 'linux/param.ph';
    unless(defined(&__undef_ARG_MAX)) {
	undef(&ARG_MAX) if defined(&ARG_MAX);
	undef(&__undef_ARG_MAX) if defined(&__undef_ARG_MAX);
    }
    eval 'sub NBBY () { &CHAR_BIT;}' unless defined(&NBBY);
    unless(defined(&NGROUPS)) {
	eval 'sub NGROUPS () { &NGROUPS_MAX;}' unless defined(&NGROUPS);
    }
    eval 'sub MAXSYMLINKS () {20;}' unless defined(&MAXSYMLINKS);
    eval 'sub CANBSIZ () { &MAX_CANON;}' unless defined(&CANBSIZ);
    eval 'sub MAXPATHLEN () { &PATH_MAX;}' unless defined(&MAXPATHLEN);
    eval 'sub NOFILE () {256;}' unless defined(&NOFILE);
    eval 'sub NCARGS () {131072;}' unless defined(&NCARGS);
    require 'sys/types.ph';
    eval 'sub setbit {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] |= 1<<(($i)% &NBBY)));
    }' unless defined(&setbit);
    eval 'sub clrbit {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] &= ~(1<<(($i)% &NBBY))));
    }' unless defined(&clrbit);
    eval 'sub isset {
        my($a,$i) = @_;
	    eval q((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))));
    }' unless defined(&isset);
    eval 'sub isclr {
        my($a,$i) = @_;
	    eval q(((($a)[($i)/ &NBBY] & (1<<(($i)% &NBBY))) == 0));
    }' unless defined(&isclr);
    unless(defined(&howmany)) {
	eval 'sub howmany {
	    my($x, $y) = @_;
    	    eval q(((($x) + (($y) - 1)) / ($y)));
	}' unless defined(&howmany);
    }
    if(defined(&__GNUC__)) {
	eval 'sub roundup {
	    my($x, $y) = @_;
    	    eval q(( &__builtin_constant_p ($y)  &&  &powerof2 ($y) ? ((($x) + ($y) - 1) & ~(($y) - 1)) : (((($x) + (($y) - 1)) / ($y)) * ($y))));
	}' unless defined(&roundup);
    } else {
	eval 'sub roundup {
	    my($x, $y) = @_;
    	    eval q((((($x) + (($y) - 1)) / ($y)) * ($y)));
	}' unless defined(&roundup);
    }
    eval 'sub powerof2 {
        my($x) = @_;
	    eval q((((($x) - 1) & ($x)) == 0));
    }' unless defined(&powerof2);
    eval 'sub MIN {
        my($a,$b) = @_;
	    eval q(((($a)<($b))?($a):($b)));
    }' unless defined(&MIN);
    eval 'sub MAX {
        my($a,$b) = @_;
	    eval q(((($a)>($b))?($a):($b)));
    }' unless defined(&MAX);
    eval 'sub DEV_BSIZE () {512;}' unless defined(&DEV_BSIZE);
}
1;
